Index: issm/branches/trunk-jpl-damage/src/c/Container/Parameters.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Parameters.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Parameters.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Parameters::Parameters(){{{1*/
+/*FUNCTION Parameters::Parameters(){{{*/
 Parameters::Parameters(){
 	enum_type=ParametersEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::~Parameters(){{{1*/
+/*FUNCTION Parameters::~Parameters(){{{*/
 Parameters::~Parameters(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Object management*/
-/*FUNCTION Parameters::Exist{{{1*/
+/*FUNCTION Parameters::Exist{{{*/
 bool Parameters::Exist(int enum_type){
 
@@ -51,5 +51,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::FindParam(bool* pbool,int enum_type){{{1*/
+/*FUNCTION Parameters::FindParam(bool* pbool,int enum_type){{{*/
 void Parameters::FindParam(bool* pbool,int enum_type){ _assert_(this);
 	
@@ -65,8 +65,8 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(int* pinteger,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(int* pinteger,int enum_type){{{*/
 void Parameters::FindParam(int* pinteger,int enum_type){ _assert_(this);
 	
@@ -82,9 +82,9 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(double* pscalar, int enum_type){{{1*/
-void Parameters::FindParam(double* pscalar, int enum_type){ _assert_(this);
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(IssmDouble* pscalar, int enum_type){{{*/
+void Parameters::FindParam(IssmDouble* pscalar, int enum_type){ _assert_(this);
 	
 	vector<Object*>::iterator object;
@@ -99,8 +99,25 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(char** pstring,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(IssmDouble* pscalar, int enum_type,IssmDouble time){{{*/
+void Parameters::FindParam(IssmDouble* pscalar, int enum_type,IssmDouble time){ _assert_(this);
+
+	vector<Object*>::iterator object;
+	Param* param=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		param=(Param*)(*object);
+		if(param->InstanceEnum()==enum_type){
+			param->GetParameterValue(pscalar,time);
+			return;
+		}
+	}
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(char** pstring,int enum_type){{{*/
 void Parameters::FindParam(char** pstring,int enum_type){ _assert_(this);
 	
@@ -116,9 +133,9 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(char*** pstringarray,int* pM,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(char*** pstringarray,int* pM,int enum_type){{{*/
 void Parameters::FindParam(char*** pstringarray,int* pM,int enum_type){ _assert_(this);
 	
@@ -134,9 +151,9 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(int** pintarray,int* pM,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(int** pintarray,int* pM,int enum_type){{{*/
 void Parameters::FindParam(int** pintarray,int* pM, int enum_type){ _assert_(this);
 
@@ -152,9 +169,9 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(int** pintarray,int* pM,int* pN,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(int** pintarray,int* pM,int* pN,int enum_type){{{*/
 void Parameters::FindParam(int** pintarray,int* pM,int *pN,int enum_type){ _assert_(this);
 
@@ -170,46 +187,46 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(double** pdoublearray,int* pM,int enum_type){{{1*/
-void Parameters::FindParam(double** pdoublearray,int* pM, int enum_type){ _assert_(this);
-
-	vector<Object*>::iterator object;
-	Param* param=NULL;
-
-	for ( object=objects.begin() ; object < objects.end(); object++ ){
-
-		param=(Param*)(*object);
-		if(param->InstanceEnum()==enum_type){
-			param->GetParameterValue(pdoublearray,pM);
-			return;
-		}
-	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(double** pdoublearray,int* pM, int* pN,int enum_type){{{1*/
-void Parameters::FindParam(double** pdoublearray,int* pM, int* pN,int enum_type){ _assert_(this);
-
-	vector<Object*>::iterator object;
-	Param* param=NULL;
-
-	for ( object=objects.begin() ; object < objects.end(); object++ ){
-
-		param=(Param*)(*object);
-		if(param->InstanceEnum()==enum_type){
-			param->GetParameterValue(pdoublearray,pM,pN);
-			return;
-		}
-	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(double*** parray,int* pM,int** pmdims_array,int** pndims_array,int enum_type){{{1*/
-void Parameters::FindParam(double*** parray,int* pM,int** pmdims_array,int** pndims_array,int enum_type){ _assert_(this);
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(IssmDouble** pIssmDoublearray,int* pM,int enum_type){{{*/
+void Parameters::FindParam(IssmDouble** pIssmDoublearray,int* pM, int enum_type){ _assert_(this);
+
+	vector<Object*>::iterator object;
+	Param* param=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		param=(Param*)(*object);
+		if(param->InstanceEnum()==enum_type){
+			param->GetParameterValue(pIssmDoublearray,pM);
+			return;
+		}
+	}
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(IssmDouble** pIssmDoublearray,int* pM, int* pN,int enum_type){{{*/
+void Parameters::FindParam(IssmDouble** pIssmDoublearray,int* pM, int* pN,int enum_type){ _assert_(this);
+
+	vector<Object*>::iterator object;
+	Param* param=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		param=(Param*)(*object);
+		if(param->InstanceEnum()==enum_type){
+			param->GetParameterValue(pIssmDoublearray,pM,pN);
+			return;
+		}
+	}
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(IssmDouble*** parray,int* pM,int** pmdims_array,int** pndims_array,int enum_type){{{*/
+void Parameters::FindParam(IssmDouble*** parray,int* pM,int** pmdims_array,int** pndims_array,int enum_type){ _assert_(this);
 	
 	vector<Object*>::iterator object;
@@ -224,8 +241,8 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(Vector** pvec,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(Vector** pvec,int enum_type){{{*/
 void Parameters::FindParam(Vector** pvec,int enum_type){ _assert_(this);
 	
@@ -241,9 +258,9 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(Matrix** pmat,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(Matrix** pmat,int enum_type){{{*/
 void Parameters::FindParam(Matrix** pmat,int enum_type){ _assert_(this);
 	
@@ -259,9 +276,9 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-
-}
-/*}}}*/
-/*FUNCTION Parameters::FindParam(FILE** pfid,int enum_type){{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+
+}
+/*}}}*/
+/*FUNCTION Parameters::FindParam(FILE** pfid,int enum_type){{{*/
 void Parameters::FindParam(FILE** pfid,int enum_type){ _assert_(this);
 
@@ -277,9 +294,9 @@
 		}
 	}
-	_error_("could not find parameter %s",EnumToStringx(enum_type));
-}
-/*}}}*/
-
-/*FUNCTION Parameters::SetParam(bool boolean,int enum_type);{{{1*/
+	_error2_("could not find parameter " << EnumToStringx(enum_type));
+}
+/*}}}*/
+
+/*FUNCTION Parameters::SetParam(bool boolean,int enum_type);{{{*/
 void   Parameters::SetParam(bool boolean,int enum_type){
 
@@ -293,5 +310,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(int integer,int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(int integer,int enum_type);{{{*/
 void   Parameters::SetParam(int integer,int enum_type){
 
@@ -305,6 +322,6 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(double scalar,int enum_type);{{{1*/
-void   Parameters::SetParam(double scalar,int enum_type){
+/*FUNCTION Parameters::SetParam(IssmDouble scalar,int enum_type);{{{*/
+void   Parameters::SetParam(IssmDouble scalar,int enum_type){
 
 	Param* param=NULL;
@@ -317,5 +334,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(char* string,int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(char* string,int enum_type);{{{*/
 void   Parameters::SetParam(char* string,int enum_type){
 
@@ -329,5 +346,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(char** stringarray,int M, int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(char** stringarray,int M, int enum_type);{{{*/
 void   Parameters::SetParam(char** stringarray,int M, int enum_type){
 
@@ -341,29 +358,29 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(double* doublearray,int M,int enum_type);{{{1*/
-void   Parameters::SetParam(double* doublearray,int M, int enum_type){
-
-	Param* param=NULL;
-	
-	/*first, figure out if the param has already been created: */
-	param=(Param*)this->FindParamObject(enum_type);
-
-	if(param) param->SetValue(doublearray,M); //already exists, just set it.
-	else this->AddObject(new DoubleVecParam(enum_type,doublearray,M)); //just add the new parameter.
-}
-/*}}}*/
-/*FUNCTION Parameters::SetParam(double* doublearray,int M,int N, int enum_type);{{{1*/
-void   Parameters::SetParam(double* doublearray,int M, int N, int enum_type){
-
-	Param* param=NULL;
-	
-	/*first, figure out if the param has already been created: */
-	param=(Param*)this->FindParamObject(enum_type);
-
-	if(param) param->SetValue(doublearray,M,N); //already exists, just set it.
-	else this->AddObject(new DoubleMatParam(enum_type,doublearray,M,N)); //just add the new parameter.
-}
-/*}}}*/
-/*FUNCTION Parameters::SetParam(int* intarray,int M,int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(IssmDouble* IssmDoublearray,int M,int enum_type);{{{*/
+void   Parameters::SetParam(IssmDouble* IssmDoublearray,int M, int enum_type){
+
+	Param* param=NULL;
+	
+	/*first, figure out if the param has already been created: */
+	param=(Param*)this->FindParamObject(enum_type);
+
+	if(param) param->SetValue(IssmDoublearray,M); //already exists, just set it.
+	else this->AddObject(new DoubleVecParam(enum_type,IssmDoublearray,M)); //just add the new parameter.
+}
+/*}}}*/
+/*FUNCTION Parameters::SetParam(IssmDouble* IssmDoublearray,int M,int N, int enum_type);{{{*/
+void   Parameters::SetParam(IssmDouble* IssmDoublearray,int M, int N, int enum_type){
+
+	Param* param=NULL;
+	
+	/*first, figure out if the param has already been created: */
+	param=(Param*)this->FindParamObject(enum_type);
+
+	if(param) param->SetValue(IssmDoublearray,M,N); //already exists, just set it.
+	else this->AddObject(new DoubleMatParam(enum_type,IssmDoublearray,M,N)); //just add the new parameter.
+}
+/*}}}*/
+/*FUNCTION Parameters::SetParam(int* intarray,int M,int enum_type);{{{*/
 void   Parameters::SetParam(int* intarray,int M, int enum_type){
 
@@ -377,5 +394,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(int* intarray,int M,int N, int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(int* intarray,int M,int N, int enum_type);{{{*/
 void   Parameters::SetParam(int* intarray,int M, int N, int enum_type){
 
@@ -389,5 +406,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(Vector* vector,int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(Vector* vector,int enum_type);{{{*/
 void   Parameters::SetParam(Vector* vector,int enum_type){
 
@@ -401,5 +418,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(Matrix* matrix,int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(Matrix* matrix,int enum_type);{{{*/
 void   Parameters::SetParam(Matrix* matrix,int enum_type){
 
@@ -413,5 +430,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::SetParam(FILE* fid,int enum_type);{{{1*/
+/*FUNCTION Parameters::SetParam(FILE* fid,int enum_type);{{{*/
 void   Parameters::SetParam(FILE* fid,int enum_type){
 
@@ -425,5 +442,5 @@
 }
 /*}}}*/
-/*FUNCTION Parameters::UnitConversion(int direction_enum);{{{1*/
+/*FUNCTION Parameters::UnitConversion(int direction_enum);{{{*/
 void   Parameters::UnitConversion(int direction_enum){
 
@@ -439,5 +456,5 @@
 /*}}}*/
 
-/*FUNCTION Parameters::FindParamObject{{{1*/
+/*FUNCTION Parameters::FindParamObject{{{*/
 Object* Parameters::FindParamObject(int enum_type){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Parameters.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Parameters.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Parameters.h	(revision 12878)
@@ -23,21 +23,22 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors*/ 
 		Parameters();
 		~Parameters();
-		/*}}}*/
-		/*numerics: {{{1*/
+
+		/*numerics*/
 		bool  Exist(int enum_type);
 
 		void  FindParam(bool* pinteger,int enum_type);
 		void  FindParam(int* pinteger,int enum_type);
-		void  FindParam(double* pscalar, int enum_type);
+		void  FindParam(IssmDouble* pscalar, int enum_type);
+		void  FindParam(IssmDouble* pscalar, int enum_type,IssmDouble time);
 		void  FindParam(char** pstring,int enum_type);
 		void  FindParam(char*** pstringarray,int* pM,int enum_type);
 		void  FindParam(int** pintarray,int* pM,int enum_type);
 		void  FindParam(int** pintarray,int* pM,int* PN,int enum_type);
-		void  FindParam(double** pdoublearray,int* pM,int enum_type);
-		void  FindParam(double** pdoublearray,int* pM,int* pN,int enum_type);
-		void  FindParam(double*** parray,int* pM, int** pmdims_array,int** pndims_array,int enum_type);
+		void  FindParam(IssmDouble** pIssmDoublearray,int* pM,int enum_type);
+		void  FindParam(IssmDouble** pIssmDoublearray,int* pM,int* pN,int enum_type);
+		void  FindParam(IssmDouble*** parray,int* pM, int** pmdims_array,int** pndims_array,int enum_type);
 		void  FindParam(Vector** pvec,int enum_type);
 		void  FindParam(Matrix** pmat,int enum_type);
@@ -46,9 +47,9 @@
 		void  SetParam(bool boolean,int enum_type);
 		void  SetParam(int integer,int enum_type);
-		void  SetParam(double scalar, int enum_type);
+		void  SetParam(IssmDouble scalar, int enum_type);
 		void  SetParam(char* string,int enum_type);
 		void  SetParam(char** stringarray,int M,int enum_type);
-		void  SetParam(double* doublearray,int M,int enum_type);
-		void  SetParam(double* doublearray,int M,int N,int enum_type);
+		void  SetParam(IssmDouble* IssmDoublearray,int M,int enum_type);
+		void  SetParam(IssmDouble* IssmDoublearray,int M,int N,int enum_type);
 		void  SetParam(int* intarray,int M,int enum_type);
 		void  SetParam(int* intarray,int M,int N,int enum_type);
@@ -59,5 +60,4 @@
 
 		Object* FindParamObject(int enum_type);
-		/*}}}*/
 
 };
Index: issm/branches/trunk-jpl-damage/src/c/Container/Results.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Results.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Results.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Results::Results(){{{1*/
+/*FUNCTION Results::Results(){{{*/
 Results::Results(){
 	enum_type=ResultsEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Results::~Results(){{{1*/
+/*FUNCTION Results::~Results(){{{*/
 Results::~Results(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Object management*/
-/*FUNCTION Results::SpawnTriaResults{{{1*/
+/*FUNCTION Results::SpawnTriaResults{{{*/
 Results* Results::SpawnTriaResults(int* indices){
 
@@ -64,5 +64,5 @@
 }
 /*}}}*/
-/*FUNCTION Results::Write{{{1*/
+/*FUNCTION Results::Write{{{*/
 void Results::Write(Parameters* parameters){
 	
Index: issm/branches/trunk-jpl-damage/src/c/Container/Results.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Results.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Results.h	(revision 12878)
@@ -20,9 +20,9 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Results();
 		~Results();
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		Results* SpawnTriaResults(int* indices);
 		void Write(Parameters* parameters);
Index: issm/branches/trunk-jpl-damage/src/c/Container/Vertices.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Vertices.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Vertices.cpp	(revision 12878)
@@ -4,5 +4,5 @@
  */
 
-/*Headers: {{{1*/
+/*Headers: {{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -25,5 +25,5 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Vertices::Vertices(){{{1*/
+/*FUNCTION Vertices::Vertices(){{{*/
 Vertices::Vertices(){
 	enum_type=VerticesEnum;
@@ -31,5 +31,5 @@
 }
 /*}}}*/
-/*FUNCTION Vertices::~Vertices(){{{1*/
+/*FUNCTION Vertices::~Vertices(){{{*/
 Vertices::~Vertices(){
 	return;
@@ -38,5 +38,5 @@
 
 /*Numerics management*/
-/*FUNCTION Vertices::DistributeDofs{{{1*/
+/*FUNCTION Vertices::DistributeDofs{{{*/
 void  Vertices::DistributeDofs(int numberofobjects,int numberofdofsperobject){
 
@@ -60,5 +60,5 @@
 	 * cpus by the total last dofs of the previus cpu, starting from 0.
 	 * First: bet number of dofs for each cpu*/
-	alldofcount=(int*)xmalloc(num_procs*sizeof(int));
+	alldofcount=xNew<int>(num_procs);
 	#ifdef _HAVE_MPI_
 	MPI_Gather(&dofcount,1,MPI_INT,alldofcount,1,MPI_INT,0,MPI_COMM_WORLD);
@@ -83,6 +83,6 @@
 	 * object that is not a clone, tell them to show their dofs, so that later on, they can get picked 
 	 * up by their clones: */
-	truedofs   =(int*)xcalloc(numberofobjects*numberofdofsperobject,sizeof(int));
-	alltruedofs=(int*)xcalloc(numberofobjects*numberofdofsperobject,sizeof(int));
+	truedofs   =xNewZeroInit<int>(numberofobjects*numberofdofsperobject);
+	alltruedofs=xNewZeroInit<int>(numberofobjects*numberofdofsperobject);
 	for (i=0;i<this->Size();i++){
 		Vertex* vertex=(Vertex*)this->GetObjectByOffset(i);
@@ -102,10 +102,10 @@
 
 	/* Free ressources: */
-	xfree((void**)&alldofcount);
-	xfree((void**)&truedofs);
-	xfree((void**)&alltruedofs);
+	xDelete<int>(alldofcount);
+	xDelete<int>(truedofs);
+	xDelete<int>(alltruedofs);
 }
 /*}}}*/
-/*FUNCTION Vertices::FlagClones{{{1*/
+/*FUNCTION Vertices::FlagClones{{{*/
 void  Vertices::FlagClones(int numberofobjects){
 
@@ -117,6 +117,6 @@
 
 	/*Allocate ranks: */
-	ranks=(int*)xmalloc(numberofobjects*sizeof(int));
-	minranks=(int*)xmalloc(numberofobjects*sizeof(int));
+	ranks=xNew<int>(numberofobjects);
+	minranks=xNew<int>(numberofobjects);
 
 	for(i=0;i<numberofobjects;i++)ranks[i]=num_procs; //no cpu can have rank num_procs. This is the maximum limit.
@@ -143,10 +143,10 @@
 
 	/*Free ressources: */
-	xfree((void**)&ranks); 
-	xfree((void**)&minranks);
+	xDelete<int>(ranks); 
+	xDelete<int>(minranks);
 
 }
 /*}}}*/
-/*FUNCTION Vertices::NumberOfVertices{{{1*/
+/*FUNCTION Vertices::NumberOfVertices{{{*/
 int Vertices::NumberOfVertices(void){
 
@@ -174,5 +174,5 @@
 }
 /*}}}*/
-/*FUNCTION Vertices::Ranks{{{1*/
+/*FUNCTION Vertices::Ranks{{{*/
 void   Vertices::Ranks(int* ranks){
 
Index: issm/branches/trunk-jpl-damage/src/c/Container/Vertices.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Container/Vertices.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Container/Vertices.h	(revision 12878)
@@ -19,9 +19,9 @@
 	public:
 
-		/*constructors, destructors: {{{1*/
+		/*constructors, destructors: {{{*/
 		Vertices();
 		~Vertices();
 		/*}}}*/
-		/*numerics: {{{1*/
+		/*numerics: {{{*/
 		void  DistributeDofs(int numberofnodes,int numdofspernode);
 		void  FlagClones(int numberofnodes);
Index: issm/branches/trunk-jpl-damage/src/c/EnumDefinitions/EnumDefinitions.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/EnumDefinitions/EnumDefinitions.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/EnumDefinitions/EnumDefinitions.h	(revision 12878)
@@ -105,4 +105,5 @@
 	MaterialsRhoIceEnum,
 	MaterialsRhoWaterEnum,
+	MaterialsRhoFreshwaterEnum,
 	MaterialsMuWaterEnum,
 	MaterialsThermalExchangeVelocityEnum,
@@ -150,8 +151,14 @@
 	SettingsResultsAsPatchesEnum,
 	SettingsWaitonlockEnum,
-	DebugPetscProfilingEnum,
-	PetscProfilingCurrentMemEnum,
-	PetscProfilingCurrentFlopsEnum,
-	PetscProfilingSolutionTimeEnum,
+	SurfaceforcingsDelta18oEnum,
+	SurfaceforcingsDelta18oSurfaceEnum,
+	SurfaceforcingsIsdelta18oEnum,
+	SurfaceforcingsPrecipitationsPresentdayEnum,
+	SurfaceforcingsTemperaturesPresentdayEnum,
+	SurfaceforcingsTemperaturesLgmEnum,
+	DebugProfilingEnum,
+	ProfilingCurrentMemEnum,
+	ProfilingCurrentFlopsEnum,
+	ProfilingSolutionTimeEnum,
 	MaxIterationConvergenceFlagEnum,
 	SteadystateMaxiterEnum,
@@ -162,4 +169,14 @@
 	SurfaceforcingsPrecipitationEnum,
 	SurfaceforcingsMassBalanceEnum,
+	SurfaceforcingsIspddEnum,
+	SurfaceforcingsIssmbgradientsEnum,
+	SurfaceforcingsMonthlytemperaturesEnum,
+	SurfaceforcingsHcEnum,
+	SurfaceforcingsSmbPosMaxEnum,
+	SurfaceforcingsSmbPosMinEnum,
+	SurfaceforcingsAPosEnum,
+	SurfaceforcingsBPosEnum,
+	SurfaceforcingsANegEnum,
+	SurfaceforcingsBNegEnum,
 	ThermalMaxiterEnum,
 	ThermalPenaltyFactorEnum,
@@ -261,4 +278,5 @@
 	IntParamEnum,
 	IntVecParamEnum,
+	TransientParamEnum,
 	MacAyeal2dIceFrontEnum,
 	MacAyeal3dIceFrontEnum,
@@ -386,4 +404,5 @@
 	StressTensorzzEnum,
 	IceVolumeEnum,
+	TotalSmbEnum,
 	/*}}}*/
 	/*Element Interpolations{{{1*/
Index: issm/branches/trunk-jpl-damage/src/c/EnumDefinitions/Synchronize.sh
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/EnumDefinitions/Synchronize.sh	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/EnumDefinitions/Synchronize.sh	(revision 12878)
@@ -2,9 +2,10 @@
 #Synchronize EnumToStringx.cpp and StringToEnumx.cpp and matlab Enums
 
-#Get all lines of EnumDefinitions2.h which hold Enum | remove all comas > put everything in file temp
+#Get all lines of EnumDefinitions2.h which hold Enum | remove all commas > put everything in file temp
 cat EnumDefinitions.h | grep -e "[0-9]Enum," -e "[a-zA-Z]Enum," | grep -v include | sed -e "s/,/ /g" | awk '{print $1}' > temp
 
 #Removed existing files
 rm $ISSM_DIR/src/m/enum/*.m
+rm $ISSM_DIR/src/m/enum/*.py
 rm $ISSM_DIR/src/c/modules/EnumToStringx/EnumToStringx.cpp
 rm $ISSM_DIR/src/c/modules/StringToEnumx/StringToEnumx.cpp
@@ -25,4 +26,5 @@
 */
 
+#include <cstring>
 #include "../../shared/shared.h"
 #include "../../include/include.h"
@@ -47,5 +49,5 @@
 
 	len=strlen(EnumToStringx(enum_in));
-	string=(char*)xmalloc((len+1)*sizeof(char));
+	string=xNew<char>(len+1);
 	memcpy(string,EnumToStringx(enum_in),(len+1)*sizeof(char));
 
@@ -55,5 +57,5 @@
 END
 #}}}
-#Build StringToEnumx.cpp {{{1
+#Build StringToEnumx.cpp {{{
 #Header
 cat <<END > $ISSM_DIR/src/c/modules/StringToEnumx/StringToEnumx.cpp
@@ -67,4 +69,5 @@
 */
 
+#include <cstring>
 #include "../../shared/shared.h"
 #include "../../include/include.h"
@@ -95,5 +98,5 @@
 cat <<END >> $ISSM_DIR/src/c/modules/StringToEnumx/StringToEnumx.cpp
 	/*If we reach this point, the string provided has not been found*/
-   _error_("Enum %s not found",name);
+	_error2_("Enum " << name << " not found");
 }
 END
@@ -102,4 +105,17 @@
 # go through the lines of temp
 ENUM=0;
+#Add header to pythonenum file{{{
+cat <<END > $ISSM_DIR/src/m/enum/EnumDefinitions.py
+"""
+
+   WARNING: DO NOT MODIFY THIS FILE
+            this file has been automatically generated by src/c/EnumDefinitions/Synchronize.sh
+            Please read src/c/EnumDefinitions/README for more information
+
+"""
+
+END
+#}}}
+
 for NAMEENUM in $(cat temp); do
 
@@ -140,7 +156,21 @@
 END
 #}}}
+	#Add case to pythonenum file{{{
+	cat <<END >> $ISSM_DIR/src/m/enum/EnumDefinitions.py
+def $(echo $NAMEENUM)():
+	"""
+	$(echo $NAMEENUM | awk {'print toupper($1)'}) - Enum of $(echo $NAME)
+
+	   Usage:
+	      macro=$NAMEENUM()
+	"""
+
+	return StringToEnum('$NAME')
+
+END
+#}}}
 
 done
-#MaximumNumberOfEnums{{{
+#MaximumNumberOfEnums (matlab){{{
 cat <<END > $ISSM_DIR/src/m/enum/MaximumNumberOfEnums.m
 function macro=MaximumNumberOfEnums()
@@ -159,4 +189,20 @@
 END
 #}}}
+#MaximumNumberOfEnums (python){{{
+cat <<END >> $ISSM_DIR/src/m/enum/EnumDefinitions.py
+def MaximumNumberOfEnums():
+	"""
+	$(echo "MaximumNumberOfEnums" | awk {'print toupper($1)'}) - Enum of MaximumNumberOfEnums
+
+	   Usage:
+	      macro=MaximumNumberOfEnums()
+	"""
+
+	return $(cat EnumDefinitions.h | grep -e "[0-9]Enum" -e "[a-zA-Z]Enum" | grep -v include \
+		| awk '{ printf "%s %s\n", NR-1, $0 }' \
+		| grep "MaximumNumberOfEnums" | awk '{print $1}')
+
+END
+#}}}
 
 #clean up{{{
